<?php

namespace STM\Import\Parser;

use STM\Utils\Classes;
use \Exception;

/**
 * Test class for ImportKey.
 * Generated by PHPUnit on 2012-08-26 at 10:56:14.
 * @group import
 */
class ImportKeyTest extends \PHPUnit_Framework_TestCase {

    /** @var ImportKey */
    private $valid;
    /** @var ImportKey */
    private $invalidKey;
    /** @var ImportKey */
    private $invalidName;
    /** @var ImportKey */
    private $invalidValueType;

    protected function setUp() {
        $this->valid = new ImportKey('N', 'name');
        $this->invalidKey = new ImportKey('', 'name');
        $this->invalidName = new ImportKey('N', new Exception(), ImportValueType::ARRAYS);
        $this->invalidValueType = new ImportKey('N', 'name', null);
    }

    public function testIsValid() {
        parent::assertTrue($this->valid->isValid());
        parent::assertFalse($this->invalidKey->isValid());
        parent::assertFalse($this->invalidName->isValid());
        parent::assertFalse($this->invalidValueType->isValid());
    }

    public function testGetKey() {
        parent::assertTrue(is_string($this->valid->getKey()));
        parent::assertFalse($this->invalidKey->getKey());
        parent::assertTrue(is_string($this->invalidName->getKey()));
        parent::assertTrue(is_string($this->invalidValueType->getKey()));
    }

    public function testGetName() {
        parent::assertTrue(is_string($this->valid->getName()));
        parent::assertTrue(is_string($this->invalidKey->getName()));
        parent::assertFalse($this->invalidName->getName());
        parent::assertTrue(is_string($this->invalidValueType->getName()));
    }

    public function testGetValueType() {
        parent::assertTrue(Classes::isClassConstant('\STM\Import\Parser\ImportValueType', $this->valid->getValueType()));
        parent::assertTrue(Classes::isClassConstant('\STM\Import\Parser\ImportValueType', $this->invalidKey->getValueType()));
        parent::assertTrue(Classes::isClassConstant('\STM\Import\Parser\ImportValueType', $this->invalidName->getValueType()));
        parent::assertFalse($this->invalidValueType->getValueType());
    }

}

?>